/* led_tristate2
   Egy LED vezérlése nyomógomb segítségével:
    - első lenyomásra a piros LED világítson
    - második lenyomásra a LED villog
    - harmadik lenyomásra a LED kialszik

    A korábbi megoldástól eltérően most switch utasítással
    kezeljük a LED különböző állapotait.
*/

const int RED_LED = 5;
const int PUSH2 = 3;

//Hardverfüggetlen rész (MSP430 Launchpad kártyán is futtatható!)
boolean waitforpress = true;     //Kezdetben lenyomásra várunk
int led_state = 0;               //Kezdetben a LED ki van kapcsolva

void setup() {
  pinMode(RED_LED, OUTPUT);      //legyen kimenet
  pinMode(PUSH2, INPUT_PULLUP);  //Bemenet belső felhúzással
}

void loop() {
  if (waitforpress) {            //Ha lenyomásra várunk és
    if (!digitalRead(PUSH2)) {   //Ha lenyomás történt...
      if (++led_state > 2) led_state = 0; //Állapot léptetése (2 után körülfordulás...)
      waitforpress = false;      //Következő stáció: felengedésre várunk
    }
  }
  else {                         //Ha felengedésre vártunk és
    if (digitalRead(PUSH2)) {    //Ha felengedést észlelünk...
      waitforpress = true;       //Következő stáció: lenyomásra várunk
    }
  }
  switch (led_state) {
    case 0: digitalWrite(RED_LED, LOW); break;
    case 1: digitalWrite(RED_LED, HIGH); break;
    default: digitalWrite(RED_LED, !digitalRead(RED_LED));
  }
  delay(250);
}
